"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _runtimeType = _interopRequireDefault(require("runtime-type"));
var _smartError = _interopRequireDefault(require("smart-error"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _construct(t, e, r) { if (_isNativeReflectConstruct()) return Reflect.construct.apply(null, arguments); var o = [null]; o.push.apply(o, e); var p = new (t.bind.apply(t, o))(); return r && _setPrototypeOf(p, r.prototype), p; }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var Shape = /*#__PURE__*/function () {
  /**
   * @param {string} name
   * @param {string} description
   * @param {Field[]} fields 
   */
  function Shape(name, description) {
    var _this = this;
    _classCallCheck(this, Shape);
    _defineProperty(this, "name", null);
    _defineProperty(this, "description", null);
    /** @type {Field[]} */
    _defineProperty(this, "fields", []);
    /** @type {Type.Type} */
    _defineProperty(this, "type", _runtimeType["default"].any);
    this.name = name;
    for (var _len = arguments.length, fields = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
      fields[_key - 2] = arguments[_key];
    }
    if (description instanceof Field) {
      fields.unshift(description);
      this.description = null;
    } else {
      this.description = description;
    }
    this.fields = fields;
    var shape = {};
    this.fields.forEach(function (field) {
      shape[_this._getFieldName(field)] = field.type;
    });
    this.type = _runtimeType["default"].shape(shape);
  }
  return _createClass(Shape, [{
    key: "toJSON",
    value: function toJSON() {
      var o = {
        name: this.name,
        description: this.description,
        shape: {},
        type: this.type.toString()
      };
      this.fields.forEach(function (field) {
        o.shape[field.name] = field;
      });
      return o;
    }
  }, {
    key: "_getFieldName",
    value: function _getFieldName(field) {
      if (field.required === undefined) {
        return field.name;
      }
      return field.required ? field.name : "".concat(field.name, "?");
    }
  }]);
}();
var ShapeArray = /*#__PURE__*/function () {
  /**
   * 
   * @param {string} name 
   * @param {string} description 
   * @param {Field[]} shape 
   */
  function ShapeArray(name, description) {
    _classCallCheck(this, ShapeArray);
    _defineProperty(this, "name", null);
    _defineProperty(this, "description", null);
    /** @type {Shape} */
    _defineProperty(this, "shape", null);
    /** @type {Type.Type} */
    _defineProperty(this, "type", _runtimeType["default"].any);
    this.name = name;
    for (var _len2 = arguments.length, fields = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
      fields[_key2 - 2] = arguments[_key2];
    }
    if (description instanceof Field) {
      fields.unshift(description);
      this.description = null;
    } else {
      this.description = description;
    }
    this.shape = _construct(Shape, ['__shape__', null].concat(fields));
    this.type = _runtimeType["default"].arrayOf(this.shape.type);
  }
  return _createClass(ShapeArray, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        name: this.name,
        description: this.description,
        shape_array: this.shape.toJSON().shape,
        type: this.type.toString()
      };
    }
  }]);
}();
var Field = exports["default"] = /*#__PURE__*/function () {
  /**
   * 
   * @param {string} name 
   * @param {Type.Type|string} type 
   * @param {string} description 
   */
  function Field(name) {
    var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _runtimeType["default"].any;
    var description = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    _classCallCheck(this, Field);
    /** @type {string} */
    _defineProperty(this, "key", null);
    /** @type {string} */
    _defineProperty(this, "name", null);
    /** @type {Type.Type} */
    _defineProperty(this, "type", null);
    /** @type {string} */
    _defineProperty(this, "description", null);
    this.key = name;
    this.name = name;
    this.type = typeof type === 'string' ? _runtimeType["default"][type] : type;
    this.description = description;
    if (!(this.type instanceof _runtimeType["default"].Type)) {
      throw new _smartError["default"]('Invalid type.');
    }
  }
  return _createClass(Field, [{
    key: "toJSON",
    value: function toJSON() {
      return {
        name: this.name,
        key: this.key,
        description: this.description,
        type: this.type.toString()
      };
    }
  }], [{
    key: "create",
    value: function create(param) {
      if (typeof param === 'string') {
        if (param.indexOf('.') > 0) {
          throw new _smartError["default"]('Cannot create shape parameter', 'no_shape');
        }
        return new this(param, _runtimeType["default"].any, null);
      }
      return new this(param.name, param.type, param.description);
    }
  }]);
}();
_defineProperty(Field, "Shape", Shape);
_defineProperty(Field, "ShapeArray", ShapeArray);